import org.junit.Test;
import static org.junit.Assert.*;

public class LifeTest {

    @Test
    public void createNewCell() {
        Life l = new Life();
        l.setAlive(0, 0);
        l.setAlive(0, 1);
        l.setAlive(0, 2);

        ILife nextGen = l.nextGeneration();

        assertTrue(nextGen.isAlive(1, 1));
    }

    @Test
    public void destroyLonelyCell() {
        Life firstGen = new Life();
        firstGen.setAlive(0, 0);
        firstGen.setAlive(0, 2);

        ILife nextGen = firstGen.nextGeneration();

        assertTrue(nextGen.isDead(0, 0));
        assertTrue(nextGen.isDead(0, 2));
    }

    @Test
    public void keepAliveCell() {
        Life firstGen = new Life();
        firstGen.setAlive(1, 1);
        firstGen.setAlive(2, 2);
        firstGen.setAlive(3, 3);

        ILife nextGen = firstGen.nextGeneration();

        assertTrue(nextGen.isAlive(2, 2));
    }

    @Test
    public void destroyCrowdedCell() {
        Life firstGen = new Life();
        firstGen.setAlive(0, 0);
        firstGen.setAlive(0, 1);
        firstGen.setAlive(0, 2);
        firstGen.setAlive(1, 0);
        firstGen.setAlive(1, 1);

        ILife nextGen = firstGen.nextGeneration();

        assertTrue(nextGen.isDead(0, 1));
        assertTrue(nextGen.isDead(1, 1));
    }
}